<script lang="ts">
export default {
  mounted() {
    this.getPostById();
  },
  data() {
    return {
      post: {},
      isEditMode: false,
      title: '',
      body: ''
    }
  },
  methods: {
    async getPostById() {
      const id = this.$route.params.id;
      const response = await fetch(`https://jsonplaceholder.typicode.com/posts/${id}`);
      const data = await response.json();
      this.post = data;
      this.title = data.title;
      this.body = data.body;
    },
    edit() {
      this.isEditMode = true;
    },
    async save() {
      const id = this.$route.params.id;
      const response = await fetch(`https://jsonplaceholder.typicode.com/posts/${id}`, { method: 'PUT', body: JSON.stringify({ title: this.title, body: this.body }), headers: { 'Content-type': 'application/json' } });
      const data = await response.json();
      this.post = data;
      this.title = data.title;
      this.body = data.body;
      this.isEditMode = false;
    }
  }
}
</script>
<template>
  <section class="post">
    <div v-if="!isEditMode">
      <h1>This is an post page {{ $route.params.id }}</h1>
      <h2>Title: {{ post.title }}</h2>
      <p>{{ post.body }}</p>
      <button @click="edit">Edit</button>
    </div>
    <div v-if="isEditMode">
      <h1>Update post id: {{ $route.params.id }}</h1>
      <textarea v-model="title" />
      <textarea v-model="body" />
      <button @click="save()">Save</button>
    </div>
    <router-view />
  </section>
</template>
